
import pandas as pd
from sklearn.utils import shuffle
from prepare.prepare_dl import read_seq_data
from prepare.prepare_ml import load_data


def get_single_data(dataset,shuffle1=False):
    if dataset in ["6mA_A.thaliana","6mA_C.elegans","6mA_C.equisetifolia","6mA_D.melanogaster",
                     "6mA_F.vesca","6mA_H.sapiens","6mA_R.chinensis","6mA_S.cerevisiae","6mA_T.thermophile",
                     "6mA_Tolypocladium","6mA_Xoc BLS256","4mC_C.equisetifolia","4mC_F.vesca","4mC_S.cerevisiae",
                     "4mC_Tolypocladium","5hmC_H.sapiens","5hmC_M.musculus"]:
        data_train,data_test = load_data(dataset)
    elif dataset in ["4mC_A.thaliana","4mC_G.pickeringii","4mC_E.coli","4mC_G.subterraneus",
                     "4mC_D.melanogaster","4mC_C.elegans","4mC_A.thaliana2","4mC_C.elegans2",
                     "4mC_D.melanogaster2","4mC_E.coli2","4mC_G.pickeringii2","4mC_G.subterraneus2"]:
        dir1 = dataset.split("_")[0]
        train_pos = "data/" + dir1 + "/" + dataset + "/train_pos.txt"
        train_neg = "data/" + dir1 + "/" + dataset + "/train_neg.txt"
        test_pos = "data/" + dir1 + "/" + dataset + "/test_pos.txt"
        test_neg = "data/" + dir1 + "/" + dataset + "/test_neg.txt"
        data_train_pos = read_seq_data(train_pos)
        data_train_neg = read_seq_data(train_neg)
        data_test_pos = read_seq_data(test_pos)
        data_test_neg = read_seq_data(test_neg)
        data_train = pd.concat([data_train_pos,data_train_neg])
        data_test = pd.concat([data_test_pos, data_test_neg])
        label_train = [1]*data_train_pos.shape[0]+[0]*data_train_neg.shape[0]
        label_test = [1] * data_test_pos.shape[0] + [0] * data_test_neg.shape[0]
        data_train["label"] = label_train
        data_test["label"] = label_test
    if shuffle1:
        data_train, data_test = shuffle(data_train),shuffle(data_test)
    return data_train,data_test



'''
combine different species data
dataset_list -- a list of dataset name
return:
    data_train -- pandas.DataFrame with columns (label, seq)
    data_test -- ..
'''
def get_muti_data(dataset_list,shuffle1=False):
    data_train_list = []
    data_test_list = []
    for dataset in dataset_list:
        data_train, data_test = get_single_data(dataset,shuffle1)
        data_train_list.append(data_train)
        data_test_list.append(data_test)
    data_train = pd.concat(data_train_list, axis=0, ignore_index=True)
    data_test = pd.concat(data_test_list, axis=0, ignore_index=True)
    if shuffle1:
        data_train, data_test = shuffle(data_train), shuffle(data_test)
    return data_train, data_test


